Index: trunk/ab5.0/abdev/abdev/abdev.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/abdev.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/abdev.cpp	(revision 625)
@@ -99,8 +99,8 @@
 	int i;
 	if(!IsWindow(hChild)) return -1;
-	for(i=0;i<MAX_WNDNUM;i++){
+	for(i=0;i<MdiInfo.size();i++){
 		if(hChild==MdiInfo[i].hwnd) break;
 	}
-	if(i==MAX_WNDNUM) i=-1;
+	if(i==MdiInfo.size()) i=-1;
 	return i;
 }
@@ -119,5 +119,5 @@
 		projectInfo.pobj_DBFileInfo->ppobj_FileInfo[i]->GetFullPath(temporary);
 
-		if(lstrcmpi(MdiInfo[WndNum].path,temporary)==0) return i;
+		if(lstrcmpi(MdiInfo[WndNum].path.c_str(),temporary)==0) return i;
 	}
 	return -1;
@@ -643,17 +643,20 @@
 	}
 	WndNum=GetWndNum(hChild);
-	if(IS_DOCUMENT_TEXT(MdiInfo[WndNum].DocType)){
-		pobj_MainMenu->EnableItem(IDM_PAGESET,MF_BYCOMMAND|MF_ENABLED);
-
-		pobj_MainMenu->EnableItem(IDM_PREVIEW,MF_BYCOMMAND|MF_ENABLED);
-
-		pobj_MainMenu->EnableItem(IDM_PRINTOUT,MF_BYCOMMAND|MF_ENABLED);
-	}
-	else{
-		pobj_MainMenu->EnableItem(IDM_PAGESET,MF_BYCOMMAND|MF_GRAYED);
-
-		pobj_MainMenu->EnableItem(IDM_PREVIEW,MF_BYCOMMAND|MF_GRAYED);
-
-		pobj_MainMenu->EnableItem(IDM_PRINTOUT,MF_BYCOMMAND|MF_GRAYED);
+	if( WndNum != -1 )
+	{
+		if(IS_DOCUMENT_TEXT(MdiInfo[WndNum].DocType)){
+			pobj_MainMenu->EnableItem(IDM_PAGESET,MF_BYCOMMAND|MF_ENABLED);
+
+			pobj_MainMenu->EnableItem(IDM_PREVIEW,MF_BYCOMMAND|MF_ENABLED);
+
+			pobj_MainMenu->EnableItem(IDM_PRINTOUT,MF_BYCOMMAND|MF_ENABLED);
+		}
+		else{
+			pobj_MainMenu->EnableItem(IDM_PAGESET,MF_BYCOMMAND|MF_GRAYED);
+
+			pobj_MainMenu->EnableItem(IDM_PREVIEW,MF_BYCOMMAND|MF_GRAYED);
+
+			pobj_MainMenu->EnableItem(IDM_PRINTOUT,MF_BYCOMMAND|MF_GRAYED);
+		}
 	}
 }
@@ -722,5 +725,5 @@
 void DuplicateTitleCheck(char *lpszTitle){
 	int i;
-	for(i=0;i<MAX_WNDNUM;i++){
+	for(i=0;i<MdiInfo.size();i++){
 		if(MdiInfo[i].hwnd){
 			if(lstrcmpi(MdiInfo[i].title,lpszTitle)==0){
@@ -747,5 +750,5 @@
 			i=GetWndNum(hChild);
 			if(IS_DOCUMENT_TEXT(MdiInfo[i].DocType)){
-				if(lstrcmpi(MdiInfo[i].path,filepath)==0) break;
+				if(lstrcmpi(MdiInfo[i].path.c_str(),filepath)==0) break;
 			}
 			hChild=GetNextWindow(hChild,GW_HWNDNEXT);
@@ -890,53 +893,54 @@
 		hChild,NULL,hInst,NULL);
 
+
 	//ウィンドウのID登録
-	for(i=0;i<MAX_WNDNUM;i++){
-		if(MdiInfo[i].hwnd==0){
-			MdiInfo[i].hwnd=hChild;
-			MdiInfo[i].DocType=DocumentType;
-			DuplicateTitleCheck(str);
-			MdiInfo[i].title=(char *)GlobalAlloc(GMEM_FIXED,lstrlen(str)+1);
-			lstrcpy(MdiInfo[i].title,str);
-			if(filepath){
-				MdiInfo[i].path=(char *)GlobalAlloc(GMEM_FIXED,lstrlen(filepath)+1);
-				lstrcpy(MdiInfo[i].path,filepath);
-			}
-			else{
-				MdiInfo[i].path=(char *)GlobalAlloc(GPTR,1);
-			}
-
-			MdiInfo[i].pMdiTextEdit = new CMdiTextEdit( &MdiInfo[i] );
-
-			MdiInfo[i].pMdiTextEdit->hEdit=hEdit;
-			MdiInfo[i].pMdiTextEdit->pobj_WebResult=new CWebResult(hChild);
-			MdiInfo[i].pMdiTextEdit->pobj_Ruler=new CRuler(hChild,i);
-			MdiInfo[i].pMdiTextEdit->hIcon=shfi.hIcon;
-			MdiInfo[i].pMdiTextEdit->buffer=buffer;
-			MdiInfo[i].pMdiTextEdit->pColorRef=(COLORREF *)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,sizeof(COLORREF)*lstrlen(buffer));
-			MdiInfo[i].pMdiTextEdit->iUnderStart=-1;
-			MdiInfo[i].pMdiTextEdit->iUnderEnd=-1;
-			MdiInfo[i].pMdiTextEdit->StartCaretPos.x=0;
-			MdiInfo[i].pMdiTextEdit->StartCaretPos.y=0;
-			MdiInfo[i].pMdiTextEdit->EndCaretPos.x=0;
-			MdiInfo[i].pMdiTextEdit->EndCaretPos.y=0;
-			MdiInfo[i].pMdiTextEdit->Temp_UpDown_CaretXPos=-1;
-			MdiInfo[i].pMdiTextEdit->bAutoScroll=0;
-			MdiInfo[i].pMdiTextEdit->iWidth_ControlTabSpace=
-				GetControlTabSpace(i,&MdiInfo[i].pMdiTextEdit->iLineNumberTextCount);
-			MdiInfo[i].pMdiTextEdit->iCharCode=iCharCode;
-			MdiInfo[i].pMdiTextEdit->iLfCode=iLfCode;
-
-			MdiInfo[i].IndentStr=0;
-
-			int flag;
-			if(mdic.style&WS_MAXIMIZE) flag=SIZE_MAXIMIZED;
-			else flag=0;
-			SendTextEditResizeEvent(hChild);
-			break;
-		}
-	}
+	MdiInfo.push_back( MDIINFO() );
+	i = MdiInfo.size()-1;
+	MdiInfo[i].hwnd=hChild;
+	MdiInfo[i].DocType=DocumentType;
+	MdiInfo[i].title="";
+	DuplicateTitleCheck(str);
+	MdiInfo[i].title=(char *)GlobalAlloc(GMEM_FIXED,lstrlen(str)+1);
+	lstrcpy(MdiInfo[i].title,str);
+	if(filepath)
+	{
+		MdiInfo[i].path = filepath;
+	}
+	else
+	{
+		MdiInfo[i].path = "";
+	}
+
+	MdiInfo[i].pMdiTextEdit = new CMdiTextEdit( &MdiInfo[i] );
+
+	MdiInfo[i].pMdiTextEdit->hEdit=hEdit;
+	MdiInfo[i].pMdiTextEdit->pobj_WebResult=new CWebResult(hChild);
+	MdiInfo[i].pMdiTextEdit->pobj_Ruler=new CRuler(hChild,i);
+	MdiInfo[i].pMdiTextEdit->hIcon=shfi.hIcon;
+	MdiInfo[i].pMdiTextEdit->buffer=buffer;
+	MdiInfo[i].pMdiTextEdit->pColorRef=(COLORREF *)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,sizeof(COLORREF)*lstrlen(buffer));
+	MdiInfo[i].pMdiTextEdit->iUnderStart=-1;
+	MdiInfo[i].pMdiTextEdit->iUnderEnd=-1;
+	MdiInfo[i].pMdiTextEdit->StartCaretPos.x=0;
+	MdiInfo[i].pMdiTextEdit->StartCaretPos.y=0;
+	MdiInfo[i].pMdiTextEdit->EndCaretPos.x=0;
+	MdiInfo[i].pMdiTextEdit->EndCaretPos.y=0;
+	MdiInfo[i].pMdiTextEdit->Temp_UpDown_CaretXPos=-1;
+	MdiInfo[i].pMdiTextEdit->bAutoScroll=0;
+	MdiInfo[i].pMdiTextEdit->iWidth_ControlTabSpace=
+		GetControlTabSpace(i,&MdiInfo[i].pMdiTextEdit->iLineNumberTextCount);
+	MdiInfo[i].pMdiTextEdit->iCharCode=iCharCode;
+	MdiInfo[i].pMdiTextEdit->iLfCode=iLfCode;
+	MdiInfo[i].IndentStr=0;
+
+
+	int flag;
+	if(mdic.style&WS_MAXIMIZE) flag=SIZE_MAXIMIZED;
+	else flag=0;
+	SendTextEditResizeEvent(hChild);
+
 
 	//ワードカラーをセット
-	if(IS_DOCUMENT_TEXT(DocumentType)) SetTextEditWordColor(i);
+	if(IS_DOCUMENT_TEXT(DocumentType)) SetTextEditWordColor(MdiInfo.size()-1);
 
 	//Docコンボボックスに追加
@@ -983,5 +987,4 @@
 
 	GlobalFree(MdiInfo[WndNum].title);
-	GlobalFree(MdiInfo[WndNum].path);
 
 	if(IS_DOCUMENT_TEXT(MdiInfo[WndNum].DocType)){
@@ -1063,4 +1066,10 @@
 		HeapDefaultFree(MdiInfo[WndNum].MdiIconEditInfo);
 	}
+	else
+	{
+		throw;
+	}
+
+	Jenga::Common::EraseVectorItem<std::vector<MDIINFO>>( MdiInfo, WndNum );
 }
 void ResizeTextEditWnd(HWND hwnd,int cx,int cy){
@@ -1711,5 +1720,5 @@
 		if(!TranslateAccelerator(hOwner,hAccel,&msg)){
 			if( projectInfo.IsOpened() ){
-				for(i=0,i2=0;i<MAX_WNDNUM;i++){
+				for(i=0,i2=0;i<MdiInfo.size();i++){
 					if(MdiInfo[i].hwnd&&MdiInfo[i].DocType==WNDTYPE_RAD){
 						if(IsDialogMessage(MdiInfo[i].MdiRadInfo->hProp_Dlg,&msg)) i2=1;
Index: trunk/ab5.0/abdev/abdev/abdev.h
===================================================================
--- trunk/ab5.0/abdev/abdev/abdev.h	(revision 624)
+++ trunk/ab5.0/abdev/abdev/abdev.h	(revision 625)
@@ -48,5 +48,5 @@
 HWND hClient;					//MDIクライアントウィンドウ
 HWND hStatusBar;				//ステータスバー
-MDIINFO MdiInfo[MAX_WNDNUM];	//MDIドキュメントウィンドウ情報
+std::vector<MDIINFO> MdiInfo;	//MDIドキュメントウィンドウ情報
 
 /* メニュー */
Index: trunk/ab5.0/abdev/abdev/abdev.vcproj
===================================================================
--- trunk/ab5.0/abdev/abdev/abdev.vcproj	(revision 624)
+++ trunk/ab5.0/abdev/abdev/abdev.vcproj	(revision 625)
@@ -433,4 +433,12 @@
 					>
 				</File>
+				<Filter
+					Name="PartialManager"
+					>
+					<File
+						RelativePath=".\src\WindowComponents\PartialManager\TextEditPartialManager.cpp"
+						>
+					</File>
+				</Filter>
 			</Filter>
 			<Filter
@@ -2768,5 +2776,5 @@
 			</Filter>
 			<Filter
-				Name="Window Components"
+				Name="WindowComponents"
 				>
 				<File
@@ -2790,4 +2798,16 @@
 					>
 				</File>
+				<Filter
+					Name="PartialManager"
+					>
+					<File
+						RelativePath=".\include\WindowComponents\PartialManager\PartialManager.h"
+						>
+					</File>
+					<File
+						RelativePath=".\include\WindowComponents\PartialManager\TextEditPartialManager.h"
+						>
+					</File>
+				</Filter>
 			</Filter>
 			<Filter
Index: trunk/ab5.0/abdev/abdev/include/ProjectManager/WindowManager.h
===================================================================
--- trunk/ab5.0/abdev/abdev/include/ProjectManager/WindowManager.h	(revision 624)
+++ trunk/ab5.0/abdev/abdev/include/ProjectManager/WindowManager.h	(revision 625)
@@ -105,12 +105,23 @@
 };
 typedef std::vector<ChildWindowInfo *> ChildWindowInfos;
+
+struct WindowType
+{
+	enum EnumType
+	{
+		Default = 0,
+		ModalDlg = 1,
+		ModelessDlg = 3,
+	};
+};
+
 class WindowInfo
 	: public WindowInfoBase
 {
 public:
-	WindowInfo()
-		: WindowInfoBase()
-		, CallBackName( NULL )
-	{
+
+	const std::string GetSourceFileName() const
+	{
+		return this->GetName() + ".ab";
 	}
 
@@ -124,11 +135,12 @@
 	}
 
-	const std::string &GetHandleName() const
-	{
-		return handleName;
-	}
-	void SetHandleName( const std::string &handleName )
-	{
-		this->handleName = handleName;
+	const std::string GetHandleName() const
+	{
+		return "h" + this->GetName();
+	}
+
+	const std::string GetCallbackName() const
+	{
+		return this->GetName() + "Proc";
 	}
 
@@ -166,11 +178,29 @@
 	{
 		return !iconResourceName.empty();
+	}
+
+	WindowType::EnumType GetType() const
+	{
+		return type;
+	}
+	void SetType( WindowType::EnumType type )
+	{
+		this->type = type;
+	}
+	bool IsDefaultWindow() const
+	{
+		return ( type == WindowType::Default );
+	}
+	bool IsModalDlg() const
+	{
+		return ( type == WindowType::ModalDlg );
+	}
+	bool IsModelessDlg() const
+	{
+		return ( type == WindowType::ModelessDlg );
 	}
 
 	//ウィンドウデータ
 	LOGFONT LogFont;
-	char *CallBackName;
-	long type;
-	char *filepath;
 
 	//子ウィンドウ管理
@@ -186,4 +216,5 @@
 	int backgroundColor;
 	std::string iconResourceName;
+	WindowType::EnumType type;
 };
 
@@ -211,7 +242,9 @@
 	{
 		WindowInfos::iterator it = this->begin();
-		for( int i=0; i!=index ;i++, it++ )
+		int i = 0;
+		while( i < index )
 		{
-			delete *it;
+			i ++;
+			it ++;
 		}
 		this->erase( it );
Index: trunk/ab5.0/abdev/abdev/nkf_class.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/nkf_class.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/nkf_class.cpp	(revision 625)
@@ -156,5 +156,4 @@
 
 BOOL CALLBACK nkfDlgCodeSave(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	static int WndNum;
 	HWND hList;
Index: trunk/ab5.0/abdev/abdev/src/MainFrame.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/src/MainFrame.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/src/MainFrame.cpp	(revision 625)
@@ -316,6 +316,6 @@
 				mii.dwTypeData=temporary;
 				mii.fType=MFT_STRING;
-				if(MdiInfo[WndNum].path[0]){
-					_splitpath(MdiInfo[WndNum].path,NULL,NULL,temporary,temp2);
+				if(!MdiInfo[WndNum].path.empty()){
+					_splitpath(MdiInfo[WndNum].path.c_str(),NULL,NULL,temporary,temp2);
 					lstrcat(temporary,temp2);
 					lstrcat(temporary," を保存(&S)");
@@ -329,5 +329,5 @@
 				/*「絶対パスをコピー」「フォルダを開く」「ファイルを削除」
 												コマンドを場合によって無効化にする */
-				if(MdiInfo[WndNum].path[0]){
+				if(!MdiInfo[WndNum].path.empty()){
 					EnableMenuItem(hTabMenu,IDM_PATH_COPY,MF_BYCOMMAND|MF_ENABLED);
 					EnableMenuItem(hTabMenu,IDM_FOLDER_OPEN,MF_BYCOMMAND|MF_ENABLED);
@@ -383,5 +383,5 @@
 		WndNum=GetWndNum(hChild);
 		if(IS_DOCUMENT_TEXT(MdiInfo[WndNum].DocType)){
-			if(lstrcmpi(MdiInfo[WndNum].path,temporary)==0) break;
+			if(lstrcmpi(MdiInfo[WndNum].path.c_str(),temporary)==0) break;
 		}
 		hChild=::GetNextWindow(hChild,GW_HWNDNEXT);
@@ -548,5 +548,5 @@
 void MainFrame::OnCmdAllSave( UINT uNotifyCode, int nID, CWindow wndCtl )
 {
-	for( int i=0;i<MAX_WNDNUM;i++){
+	for( int i=0;i<MdiInfo.size();i++){
 		if(MdiInfo[i].hwnd) SaveDocument(MdiInfo[i].hwnd,NULL);
 	}
@@ -585,10 +585,16 @@
 	if(!hChild) return;
 	int WndNum=GetWndNum(hChild);
-	if(IS_DOCUMENT_TEXT(MdiInfo[WndNum].DocType))
+	if( IS_DOCUMENT_TEXT(MdiInfo[WndNum].DocType) )
+	{
 		TextEdit_UndoCommand(WndNum);
-	else if(MdiInfo[WndNum].DocType==WNDTYPE_RAD)
+	}
+	else if( MdiInfo[WndNum].DocType == WNDTYPE_RAD )
+	{
 		Rad_UndoCommand(WndNum);
-	else if(MdiInfo[WndNum].DocType==WNDTYPE_ICONEDIT)
+	}
+	else if( MdiInfo[WndNum].DocType == WNDTYPE_ICONEDIT )
+	{
 		IconEdit_UndoCommand(WndNum);
+	}
 }
 
@@ -986,7 +992,7 @@
 		if(!SetRunning(hChild)) return;
 		if(IsNeedCompile(MdiInfo[GetWndNum(hChild)].path,1))
-			sprintf(temporary,"\"%s\" /debug /run /wnd:%08x",MdiInfo[GetWndNum(hChild)].path,m_hWnd);
+			sprintf(temporary,"\"%s\" /debug /run /wnd:%08x",MdiInfo[GetWndNum(hChild)].path.c_str(),m_hWnd);
 		else
-			sprintf(temporary,"\"%s\" /run /wnd:%08x",MdiInfo[GetWndNum(hChild)].path,m_hWnd);
+			sprintf(temporary,"\"%s\" /run /wnd:%08x",MdiInfo[GetWndNum(hChild)].path.c_str(),m_hWnd);
 
 		//ブレークポイントをセーブ
@@ -1051,5 +1057,5 @@
 		//単独ソースコード
 		if(!SetRunning(hChild)) return;
-		sprintf(temporary,"\"%s\" /debug /wnd:%08x",MdiInfo[GetWndNum(hChild)].path,m_hWnd);
+		sprintf(temporary,"\"%s\" /debug /wnd:%08x",MdiInfo[GetWndNum(hChild)].path.c_str(),m_hWnd);
 	}
 
@@ -1165,5 +1171,5 @@
 		//単独ソースコード
 		if(!SetRunning(hChild)) return;
-		sprintf(temporary,"\"%s\" /wnd:%08x",MdiInfo[GetWndNum(hChild)].path,m_hWnd);
+		sprintf(temporary,"\"%s\" /wnd:%08x",MdiInfo[GetWndNum(hChild)].path.c_str(),m_hWnd);
 	}
 
@@ -1224,5 +1230,5 @@
 
 		//単独ソースコード
-		_splitpath(MdiInfo[GetWndNum(hChild)].path,temporary,temp2,temp3,NULL);
+		_splitpath(MdiInfo[GetWndNum(hChild)].path.c_str(),temporary,temp2,temp3,NULL);
 		lstrcat(temporary,temp2);
 		lstrcat(temporary,temp3);
@@ -1403,5 +1409,5 @@
 	HWND hChild=::GetWindow(hClient,GW_CHILD);
 	int WndNum=GetWndNum(hChild);
-	for(int i=0;i<MAX_WNDNUM;i++){
+	for(int i=0;i<MdiInfo.size();i++){
 		if(i==WndNum) continue;
 		if(MdiInfo[i].hwnd) SendMessage(MdiInfo[i].hwnd,WM_CLOSE,0,0);
@@ -1415,7 +1421,7 @@
 
 	//絶対パスをコピー
-	HGLOBAL hGlobal=(char *)GlobalAlloc(GMEM_MOVEABLE,lstrlen(MdiInfo[WndNum].path)+1);
+	HGLOBAL hGlobal=(char *)GlobalAlloc(GMEM_MOVEABLE,MdiInfo[WndNum].path.size()+1);
 	char *pTemp=(char *)GlobalLock(hGlobal);
-	lstrcpy(pTemp,MdiInfo[WndNum].path);
+	lstrcpy(pTemp,MdiInfo[WndNum].path.c_str());
 	GlobalUnlock(hGlobal);
 
@@ -1433,5 +1439,5 @@
 
 	char temporary[1024], temp2[1024];
-	_splitpath(MdiInfo[WndNum].path,temporary,temp2,NULL,NULL);
+	_splitpath(MdiInfo[WndNum].path.c_str(),temporary,temp2,NULL,NULL);
 	lstrcat(temporary,temp2);
 
@@ -1445,5 +1451,5 @@
 
 	char temporary[1024], temp2[1024];
-	_splitpath(MdiInfo[WndNum].path,NULL,NULL,temporary,temp2);
+	_splitpath(MdiInfo[WndNum].path.c_str(),NULL,NULL,temporary,temp2);
 	lstrcat(temporary,temp2);
 
@@ -1455,5 +1461,5 @@
 	fo.hwnd=m_hWnd;
 	fo.wFunc=FO_DELETE;
-	fo.pFrom =MdiInfo[WndNum].path;
+	fo.pFrom =MdiInfo[WndNum].path.c_str();
 	fo.pTo="\0";
 	fo.fFlags =FOF_ALLOWUNDO|FOF_NOCONFIRMATION;
Index: trunk/ab5.0/abdev/abdev/src/ProjectManager/ProjectManager.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/src/ProjectManager/ProjectManager.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/src/ProjectManager/ProjectManager.cpp	(revision 625)
@@ -267,5 +267,4 @@
 void Project::Save()
 {
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,i3,WndNum;
 	char temporary[MAX_PATH],buffer[32767];
@@ -284,5 +283,5 @@
 				for(i=0;i<this->pobj_DBFileInfo->iNum;i++){
 					this->pobj_DBFileInfo->ppobj_FileInfo[i]->GetFullPath(temporary);
-					if(lstrcmpi(MdiInfo[WndNum].path,temporary)==0){
+					if(lstrcmpi(MdiInfo[WndNum].path.c_str(),temporary)==0){
 						SaveDocument(hChild,NULL);
 						break;
@@ -297,5 +296,5 @@
 					lstrcpy(temporary,resourceItem.filepath.c_str());
 					lstrcpy( temporary, this->GetWorkDir().GetFullPath( temporary ).c_str() );
-					if(lstrcmpi(MdiInfo[WndNum].path,temporary)==0){
+					if(lstrcmpi(MdiInfo[WndNum].path.c_str(),temporary)==0){
 						SaveDocument(hChild,NULL);
 						break;
@@ -533,5 +532,4 @@
 {
 	extern HANDLE hHeap;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,WndNum;
 	HWND hChild,hCloseChild;
@@ -553,5 +551,5 @@
 			for(i=0;i<this->pobj_DBFileInfo->iNum;i++){
 				this->pobj_DBFileInfo->ppobj_FileInfo[i]->GetFullPath(temporary);
-				if(lstrcmpi(MdiInfo[WndNum].path,temporary)==0){
+				if(lstrcmpi(MdiInfo[WndNum].path.c_str(),temporary)==0){
 
 					//変更フラグをオフにする
@@ -575,5 +573,6 @@
 		else if(MdiInfo[WndNum].DocType==WNDTYPE_MENU){
 			for(i=0;i<this->NumberOfMenu;i++){
-				if(lstrcmp(MdiInfo[WndNum].path,this->pMenuInfo[i].IdName)==0){
+				if( MdiInfo[WndNum].path == this->pMenuInfo[i].IdName )
+				{
 					SendMessage(hCloseChild,WM_CLOSE,0,0);
 					break;
@@ -585,5 +584,5 @@
 				lstrcpy(temporary,this->resourceManager.iconResources[i].filepath.c_str());
 				lstrcpy( temporary, this->GetWorkDir().GetFullPath( temporary ).c_str() );
-				if(lstrcmpi(MdiInfo[WndNum].path,temporary)==0){
+				if(lstrcmpi(MdiInfo[WndNum].path.c_str(),temporary)==0){
 					SendMessage(hCloseChild,WM_CLOSE,0,0);
 					break;
@@ -602,7 +601,4 @@
 	BOOST_FOREACH( ActiveBasic::PM::WindowInfo *pWindowInfo, windowInfos )
 	{
-		HeapDefaultFree(pWindowInfo->CallBackName);
-		HeapDefaultFree(pWindowInfo->filepath);
-
 		//子ウィンドウのメモリを解放
 		BOOST_FOREACH( ActiveBasic::PM::ChildWindowInfo *pChildWindowInfo, pWindowInfo->childWindowInfos )
